package fishrungames.yelpmapapp

import android.os.AsyncTask
import com.google.gson.JsonObject
import com.google.gson.Gson
import com.google.gson.reflect.TypeToken


/**
 * Created by mephi on 10.06.2017.
 */


class HandleResponseAsyncTask(val onUpdateMapMarkers : ((Map<String, MapMarkerRecord>) -> Unit)) : AsyncTask<JsonObject, Int, Map<String, MapMarkerRecord>>()
{


    override fun doInBackground(vararg response : JsonObject): Map<String, MapMarkerRecord> {

        val newMapMarkers = mutableMapOf<String, MapMarkerRecord>()

        try {

            for (businessElement in response[0].getAsJsonArray("businesses")) {

                val mapMarkerRecordType = object : TypeToken<MapMarkerRecord>() {}.type

                val mapMarkerRecord = Gson().fromJson<MapMarkerRecord>(businessElement, mapMarkerRecordType)

                newMapMarkers[mapMarkerRecord.name] = mapMarkerRecord

            }

        }
        catch (e : Exception)
        {
            e.printStackTrace()

        }

        return newMapMarkers
    }

    override fun onPostExecute(result: Map<String, MapMarkerRecord>) {
        super.onPostExecute(result)

        onUpdateMapMarkers(result)

    }
}